#include <pspkernel.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pspgu.h>
#include <pspgum.h>
#include <pspdisplay.h>
#include <time.h>
#include <pspdebug.h>
#include <intraFont.h>
#include <pspctrl.h>
PSP_MODULE_INFO("CTSX", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)
// グローバル変数宣言
enum colors {
	RED = 0xFF0000FF,GREEN = 0xFF00FF00,BLUE = 0xFFFF0000,WHITE = 0xFFFFFFFF,
	LITEGRAY = 0xFFBFBFBF,GRAY = 0xFF7F7F7F,DARKGRAY = 0xFF3F3F3F,BLACK = 0xFF000000,
};
intraFont* ltn[16];
intraFont* jpn0;
static char m_cStage[12][12];
SceCtrlData pad,padBefore;
static char *m_CTSX_char[]={"　","○","△","□","×","◆"};
unsigned long m_CTSX_color[]={WHITE,RED,GREEN,BLUE,DARKGRAY,BLACK};
int m_CurX,m_CurY;
unsigned long m_ulLifeTime,m_ulMakeTime;
// 変数初期化関数
void InitParam(){
	m_CurX=5; m_CurY=10; m_ulLifeTime=1; m_ulMakeTime=300;
}
// 初期化ルーチン集合
void MyInit(){
	pspDebugScreenInit(); pspDebugScreenPrintf("Loading fonts..\n");
	char file[40];
	int i;
	intraFontInit();
	for (i = 0; i < 16; i++) {
		sprintf(file, "flash0:/font/ltn%d.pgf", i); ltn[i] = intraFontLoad(file,0);
	}
	// 日本語フォントをロード
    jpn0 = intraFontLoad("flash0:/font/jpn0.pgf",INTRAFONT_STRING_SJIS);
    intraFontSetEncoding(jpn0, INTRAFONT_STRING_UTF8); // エンコードをUTF8に。
	sceGuInit(); // GU初期化
	sceGuStart(GU_DIRECT, list);
	sceGuDrawBuffer(GU_PSM_8888, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x88000, BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT);
	sceGuDepthRange(65535, 0);
	sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST);
	sceGuDepthFunc(GU_GEQUAL);
	sceGuEnable(GU_DEPTH_TEST);
	sceGuFrontFace(GU_CW);
	sceGuShadeModel(GU_SMOOTH);
	sceGuEnable(GU_CULL_FACE);
	sceGuEnable(GU_CLIP_PLANES);
	sceGuEnable(GU_BLEND);
	sceGuBlendFunc(GU_ADD, GU_SRC_ALPHA, GU_ONE_MINUS_SRC_ALPHA, 0, 0);
	sceGuFinish();
	sceGuSync(0,0);
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);
}
// 描画開始関数
void MyGuStart(){
	sceGuStart(GU_DIRECT, list);
	sceGumMatrixMode(GU_PROJECTION);
	sceGumLoadIdentity();
	sceGumPerspective( 75.0f, 16.0f/9.0f, 0.5f, 1000.0f);
    sceGumMatrixMode(GU_VIEW);
	sceGumLoadIdentity();
	sceGumMatrixMode(GU_MODEL);
	sceGumLoadIdentity();
	sceGuClearColor(WHITE); // 背景色
	sceGuClearDepth(0);
	sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
}
// 描画終了関数
void MyGuEnd(){
	sceGuFinish();
	sceGuSync(0,0);
	sceDisplayWaitVblankStart();
	sceGuSwapBuffers();
}
// タイトル画面（スタートボタンで脱出）
void Title(){
	while(pad.Buttons!=PSP_CTRL_START){
		sceCtrlReadBufferPositive(&pad, 1);
		MyGuStart(); // 描画開始
		intraFontSetStyle(jpn0,8.0f,WHITE,BLACK,INTRAFONT_ALIGN_CENTER);
		intraFontPrint(jpn0,240,180,m_CTSX_char[rand()%4+1]);
		intraFontSetStyle(jpn0, 3.0f,BLACK,GREEN,INTRAFONT_ALIGN_CENTER);
		intraFontPrint(jpn0,240,120,"Ｃ－Ｔ－Ｓ－Ｘ");
		intraFontSetStyle(ltn[0], 1.0f,BLACK,RED,INTRAFONT_ALIGN_CENTER);
		intraFontPrint(ltn[0],240,180,"PRESS START BUTTON");
		MyGuEnd(); // 描画終了
	}
}

// ステージを1行上にスクロール
void StageScroll(){
	unsigned long x=0,y=0;
	// 1段上昇して一番下にランダムで新たなキャラを配置
	for(y=1;y<=9;y++){ for(x=1;x<=10;x++){ m_cStage[x][y] = m_cStage[x][y+1]; } }
	for(x=1;x<=10;x++) m_cStage[x][10] = rand()%5;
	m_ulMakeTime--; // スクロールする都度ちょっとずつ速くなる
}

// ステージ情報クリア(外枠の0,0～11,11に番兵として5をセットする)
void StageInit(){
	int i=0;
	memset(m_cStage,0,sizeof(m_cStage)); // ステージ情報クリア
	for(i=0;i<=11;i++){
		m_cStage[i][0]=5; m_cStage[i][11]=5;
		m_cStage[0][i]=5; m_cStage[11][i]=5;
	}
	StageScroll(); // 1行だけは作る
}

// ○△□×ルーチン
void CirRoutine(){
	int iPenaltyFlag=0,iDeleteCount=0,i=0;
	static char cDeleteLine[11];
	switch(m_cStage[m_CurX][m_CurY]){
		case 0:m_cStage[m_CurX][m_CurY]=1; break;
		case 1:break;
		default:m_cStage[m_CurX][m_CurY]=1; iPenaltyFlag=1; break; // 上書ペナルティ
	}
	memset(cDeleteLine,0,sizeof(cDeleteLine));
	for(i=m_CurX;i>0;i--){
		if(m_cStage[i][m_CurY]==1){
			iDeleteCount++; cDeleteLine[i]=1; // この時点で消去フラグを立てる
		}else break;
	}
	for(i=m_CurX+1;i<11;i++){
		if(m_cStage[i][m_CurY]==1){
			iDeleteCount++; cDeleteLine[i]=1; //同上
		}else break;
	}
	// 連続4個以上の場合は消去する
	if(iDeleteCount>=4){
		for(i=1;i<=10;i++){
			if(cDeleteLine[i]==1) m_cStage[i][m_CurY]=0;
		}
	}
	if(iPenaltyFlag) StageScroll(); // ペナルティの場合は最後にスクロール
}
void TriRoutine(){
	int iPenaltyFlag=0,iDeleteCount=0,i=0;
	static char cDeleteLine[11];
	switch(m_cStage[m_CurX][m_CurY]){
		case 0:m_cStage[m_CurX][m_CurY]=2; break;
		case 2:break;
		default:m_cStage[m_CurX][m_CurY]=2; iPenaltyFlag=1; break; // 上書ペナルティ
	}
	memset(cDeleteLine,0,sizeof(cDeleteLine));
	for(i=m_CurY;i>0;i--){
		if(m_cStage[m_CurX][i]==2){
			iDeleteCount++; cDeleteLine[i]=1; // この時点で消去フラグを立てる
		}else break;
	}
	for(i=m_CurY+1;i<11;i++){
		if(m_cStage[m_CurX][i]==2){
			iDeleteCount++; cDeleteLine[i]=1; //同上
		}else break;
	}
	// 連続4個以上の場合は消去する
	if(iDeleteCount>=4){
		for(i=1;i<=10;i++){
			if(cDeleteLine[i]==1) m_cStage[m_CurX][i]=0;
		}
	}
	if(iPenaltyFlag) StageScroll(); // ペナルティの場合は最後にスクロール
}
void SquRoutine(){
	int iPenaltyFlag=0,x=0,y=0;
	static char cDeleteArea[11][11];
	switch(m_cStage[m_CurX][m_CurY]){
		case 0:m_cStage[m_CurX][m_CurY]=3; break;
		case 3:break;
		default:m_cStage[m_CurX][m_CurY]=3; iPenaltyFlag=1; break; // 上書ペナルティ
	}
	memset(cDeleteArea,0,sizeof(cDeleteArea));
	// 上下左右走査＆消去
	if(m_cStage[m_CurX-1][m_CurY]==3 && m_cStage[m_CurX-1][m_CurY-1]==3 &&
		m_cStage[m_CurX][m_CurY-1]==3){
		cDeleteArea[m_CurX-1][m_CurY]=1; cDeleteArea[m_CurX-1][m_CurY-1]=1;
		cDeleteArea[m_CurX][m_CurY-1]=1; cDeleteArea[m_CurX][m_CurY]=1;
	}
	if(m_cStage[m_CurX+1][m_CurY]==3 && m_cStage[m_CurX+1][m_CurY+1]==3 &&
		m_cStage[m_CurX][m_CurY+1]==3){
		cDeleteArea[m_CurX+1][m_CurY]=1; cDeleteArea[m_CurX+1][m_CurY+1]=1;
		cDeleteArea[m_CurX][m_CurY+1]=1; cDeleteArea[m_CurX][m_CurY]=1;
	}
	if(m_cStage[m_CurX+1][m_CurY]==3 && m_cStage[m_CurX+1][m_CurY-1]==3 &&
		m_cStage[m_CurX][m_CurY-1]==3){
		cDeleteArea[m_CurX+1][m_CurY]=1; cDeleteArea[m_CurX+1][m_CurY-1]=1;
		cDeleteArea[m_CurX][m_CurY-1]=1; cDeleteArea[m_CurX][m_CurY]=1;
	}
	if(m_cStage[m_CurX-1][m_CurY]==3 && m_cStage[m_CurX-1][m_CurY+1]==3 &&
		m_cStage[m_CurX][m_CurY+1]==3){
		cDeleteArea[m_CurX-1][m_CurY]=1; cDeleteArea[m_CurX-1][m_CurY+1]=1;
		cDeleteArea[m_CurX][m_CurY+1]=1; cDeleteArea[m_CurX][m_CurY]=1;
	}
	// 最後に消去エリアを丸ごと消す
	for(y=1;y<=10;y++){
		for(x=1;x<=10;x++){
			if(cDeleteArea[x][y]==1) m_cStage[x][y]=0;
		}
	}
	if(iPenaltyFlag) StageScroll(); // ペナルティの場合は最後にスクロール
}
void CroRoutine(){
	int iPenaltyFlag=0;
	switch(m_cStage[m_CurX][m_CurY]){
		case 0:m_cStage[m_CurX][m_CurY]=4; break;
		case 4:break;
		default:m_cStage[m_CurX][m_CurY]=4; iPenaltyFlag=1; break; // 上書ペナルティ
	}
	// 左上・左下・右上・右下を走査して消去する
	if(m_cStage[m_CurX-1][m_CurY-1]==4 && m_cStage[m_CurX-1][m_CurY+1]==4 &&
		m_cStage[m_CurX+1][m_CurY-1]==4 && m_cStage[m_CurX+1][m_CurY+1]==4){
		m_cStage[m_CurX-1][m_CurY-1]=0; m_cStage[m_CurX-1][m_CurY+1]=0;
		m_cStage[m_CurX+1][m_CurY-1]=0; m_cStage[m_CurX+1][m_CurY+1]=0;
		m_cStage[m_CurX][m_CurY]=0;
	}
	if(iPenaltyFlag) StageScroll(); // ペナルティの場合は最後にスクロール
}

void GameOver(){
	intraFontSetStyle(ltn[0], 2.0f,BLACK,RED,INTRAFONT_ALIGN_CENTER);
	intraFontPrint(ltn[0],240,120,"GAME OVER");
	intraFontSetStyle(ltn[0], 1.0f,BLACK,RED,INTRAFONT_ALIGN_CENTER);
	intraFontPrint(ltn[0],240,180,"PRESS START BUTTON");
	MyGuEnd(); // 描画終了
	while(pad.Buttons!=PSP_CTRL_START){
		sceCtrlReadBufferPositive(&pad, 1);
	}
	InitParam(); StageInit(); // ゲームオーバー後に変数とステージ初期化
}

// メインルーチン
int main() {
	unsigned long i=0,x=0,y=0;
	// キー入力初期化
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	InitParam();	// 変数初期化
	MyInit();		// グラフィック関連初期化ルーチンコール
	Title(); 		// タイトル画面コール
	StageInit();	// ステージ情報クリア
	// メインループスタート
	while(1){
		MyGuStart(); // 描画開始
		// ステージを描画
		for(y=0;y<=11;y++){
			for(x=0;x<=11;x++){
				intraFontSetStyle(jpn0,1.0f,m_CTSX_color[(int)m_cStage[x][y]],WHITE,INTRAFONT_ALIGN_CENTER);
				intraFontPrint(jpn0,150+x*16,35+y*20,m_CTSX_char[(int)m_cStage[x][y]]);
			}
		}
		// キー処理(通常は同時押しのためAND判定だが、誤爆を防ぐためイコールで判定)
		sceCtrlReadBufferPositive(&pad, 1);
		if((pad.Buttons & PSP_CTRL_LTRIGGER) || (pad.Buttons != padBefore.Buttons)){
			// 上下左右
			if((pad.Buttons==PSP_CTRL_UP   ) && m_CurY>1)  m_CurY--;
			if((pad.Buttons==PSP_CTRL_DOWN ) && m_CurY<10) m_CurY++;
			if((pad.Buttons==PSP_CTRL_LEFT ) && m_CurX>1)  m_CurX--;
			if((pad.Buttons==PSP_CTRL_RIGHT) && m_CurX<10) m_CurX++;
			// ○△□×
			if(pad.Buttons==PSP_CTRL_CIRCLE) CirRoutine();
			if(pad.Buttons==PSP_CTRL_TRIANGLE) TriRoutine();
			if(pad.Buttons==PSP_CTRL_SQUARE) SquRoutine();
			if(pad.Buttons==PSP_CTRL_CROSS) CroRoutine();
			padBefore.Buttons = pad.Buttons; // 前回の入力情報を控える
		}
		// ステージの上にカーソルを描画(スクロールまで120フレーム未満の場合は赤色で)
		if(m_ulLifeTime%m_ulMakeTime>m_ulMakeTime-60)
			intraFontSetStyle(jpn0,1.2f,RED,WHITE,INTRAFONT_ALIGN_CENTER);
		else
			intraFontSetStyle(jpn0,1.2f,LITEGRAY,WHITE,INTRAFONT_ALIGN_CENTER);
		intraFontPrint(jpn0,150+m_CurX*16,35+m_CurY*20,"※");
		// 生存時間を描画
		intraFontSetStyle(ltn[1],1.0f,BLACK,WHITE,INTRAFONT_ALIGN_LEFT);
		intraFontPrintf(ltn[1],100,18,"Time : %08ld / %04ld",m_ulLifeTime++,m_ulMakeTime);
		// ゲームオーバー判定を先に行う(スクロールタイミングで最上段チェック)
		if(m_ulLifeTime%m_ulMakeTime==0){
			for(x=1;x<=10;x++){
				if(m_cStage[x][1]!=0){
					GameOver(); break;
				}
			}
		}
		// 新しい段を生成(m_ulLifeTimeがm_ulMakeTimeで割り切れたとき)
		if(m_ulLifeTime%m_ulMakeTime==0) StageScroll();
		MyGuEnd(); // 描画終了
	}
	// 各種アンロード処理は一応残す。通常はHOMEボタン処理時に実行する。
	for (i = 0; i < 16; i++) intraFontUnload(ltn[i]);
	intraFontUnload(jpn0); intraFontShutdown(); sceKernelExitGame();
	return 0;
}
